---
title: Using Fetch
slug: Web/API/Fetch_API/Using_Fetch
tags:
  - API
  - BODY
  - Experimental
  - Fetch
  - Guide
  - HTTP
  - Promise
  - Response
  - fetch POST & string body
  - request
---
<p>{{DefaultAPISidebar("Fetch API")}}</p>

<div class="summary">
<p>The <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a> provides a JavaScript interface for accessing and manipulating parts of the HTTP pipeline, such as requests and responses. It also provides a global {{domxref("GlobalFetch.fetch","fetch()")}} method that provides an easy, logical way to fetch resources asynchronously across the network.</p>
</div>

<p>This kind of functionality was previously achieved using {{domxref("XMLHttpRequest")}}. Fetch provides a better alternative that can be easily used by other technologies such as {{domxref("ServiceWorker_API", "Service Workers")}}. Fetch also provides a single logical place to define other HTTP-related concepts such as CORS and extensions to HTTP.</p>

<p>The <code>fetch</code> specification differs from <code>jQuery.ajax()</code> in three main ways:</p>

<ul>
 <li>The Promise returned from <code>fetch()</code> <strong>won’t reject on HTTP error status</strong> even if the response is an HTTP 404 or 500. Instead, it will resolve normally (with <code>ok</code> status set to false), and it will only reject on network failure or if anything prevented the request from completing.</li>
 <li><code>fetch()</code> <strong><s>won't</s> can receive cross-site cookies</strong>; you <s>can’t</s> can establish a cross site session using fetch. <s>{{HTTPHeader("Set-Cookie")}} headers from other sites are silently ignored.</s></li>
 <li><code>fetch</code><strong> won’t send cookies</strong>, unless you set the <em>credentials</em> <a href="/en-US/docs/Web/API/WindowOrWorkerGlobalScope/fetch#Parameters">init option</a>. (Since <a href="https://github.com/whatwg/fetch/pull/585" rel="nofollow noopener">Aug 25, 2017</a>. The spec changed the default credentials policy to <code>same-origin</code>. Firefox changed since 61.0b13.)</li>
</ul>

<p>A basic fetch request is really simple to set up. Have a look at the following code:</p>

<pre class="brush: js notranslate">fetch('http://example.com/movies.json')
  .then(response =&gt; response.json())
  .then(data =&gt; console.log(data));
</pre>

<p>Here we are fetching a JSON file across the network and printing it to the console. The simplest use of <code>fetch()</code> takes one argument — the path to the resource you want to fetch — and returns a promise containing the response (a {{domxref("Response")}} object).</p>

<p>This is just an HTTP response, not the actual JSON. To extract the JSON body content from the response, we use the {{domxref("Body.json","json()")}} method (defined on the {{domxref("Body")}} mixin, which is implemented by both the {{domxref("Request")}} and {{domxref("Response")}} objects.)</p>

<div class="note">
<p><strong>Note</strong>: The Body mixin also has similar methods to extract other types of body content; see the {{anch("Body")}} section for more.</p>
</div>

<p>Fetch requests are controlled by the <code>connect-src</code> directive of <a href="/en-US/docs/Security/CSP/CSP_policy_directives">Content Security Policy</a> rather than the directive of the resources it's retrieving.</p>

<h3 id="Supplying_request_options">Supplying request options</h3>

<p>The <code>fetch()</code> method can optionally accept a second parameter, an <code>init</code> object that allows you to control a number of different settings:</p>

<p>See {{domxref("GlobalFetch.fetch","fetch()")}} for the full options available, and more details.</p>

<pre class="brush: js notranslate">// Example POST method implementation:
async function postData(url = '', data = {}) {
  // Default options are marked with *
  const response = await fetch(url, {
    method: 'POST', // *GET, POST, PUT, DELETE, etc.
    mode: 'cors', // no-cors, *cors, same-origin
    cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
    credentials: 'same-origin', // include, *same-origin, omit
    headers: {
      'Content-Type': 'application/json'
      // 'Content-Type': 'application/x-www-form-urlencoded',
    },
    redirect: 'follow', // manual, *follow, error
    referrerPolicy: 'no-referrer', // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
    body: JSON.stringify(data) // body data type must match "Content-Type" header
  });
  return response.json(); // parses JSON response into native JavaScript objects
}

postData('https://example.com/answer', { answer: 42 })
  .then(data =&gt; {
    console.log(data); // JSON data parsed by `data.json()` call
  });
</pre>

<p>Note that <code>mode: "no-cors"</code> only allows a limited set of headers in the request:</p>

<ul>
 <li><code>Accept</code></li>
 <li><code>Accept-Language</code></li>
 <li><code>Content-Language</code></li>
 <li><code>Content-Type</code> with a value of <code>application/x-www-form-urlencoded</code>, <code>multipart/form-data</code>, or <code>text/plain</code></li>
</ul>

<h3 id="Sending_a_request_with_credentials_included">Sending a request with credentials included</h3>

<p>To cause browsers to send a request with credentials included, even for a cross-origin call, add <code>credentials: 'include'</code> to the <code>init</code> object you pass to the <code>fetch()</code> method.</p>

<div class="note">
<p><strong>Note</strong>: <code>Access-Control-Allow-Origin</code> is prohibited from using a wildcard for requests with <code>credentials: 'include'</code>. In such cases, the exact origin must be provided; even if you are using a CORS unblocker extension, the requests will still fail.</p>
</div>

<pre class="brush: js notranslate">fetch('https://example.com', {
  credentials: 'include'
});
</pre>

<p>If you only want to send credentials if the request URL is on the same origin as the calling script, add <code>credentials: 'same-origin'</code>.</p>

<pre class="brush: js notranslate">// The calling script is on the origin 'https://example.com'

fetch('https://example.com', {
  credentials: 'same-origin'
});
</pre>

<p>To instead ensure browsers don’t include credentials in the request, use <code>credentials: 'omit'</code>.</p>

<pre class="brush: js notranslate">fetch('https://example.com', {
  credentials: 'omit'
})
</pre>

<h3 id="Uploading_JSON_data">Uploading JSON data</h3>

<p>Use {{domxref("GlobalFetch.fetch","fetch()")}} to POST JSON-encoded data.</p>

<pre class="brush: js notranslate">const data = { username: 'example' };

fetch('https://example.com/profile', {
  method: 'POST', // or 'PUT'
  headers: {
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(data),
})
.then(response =&gt; response.json())
.then(data =&gt; {
  console.log('Success:', data);
})
.catch((error) =&gt; {
  console.error('Error:', error);
});
</pre>

<h3 id="Uploading_a_file">Uploading a file</h3>

<p>Files can be uploaded using an HTML <code>&lt;input type="file" /&gt;</code> input element, {{domxref("FormData.FormData","FormData()")}} and {{domxref("WindowOrWorkerGlobalScope/fetch","fetch()")}}.</p>

<pre class="brush: js notranslate">const formData = new FormData();
const fileField = document.querySelector('input[type="file"]');

formData.append('username', 'abc123');
formData.append('avatar', fileField.files[0]);

fetch('https://example.com/profile/avatar', {
  method: 'PUT',
  body: formData
})
.then(response =&gt; response.json())
.then(result =&gt; {
  console.log('Success:', result);
})
.catch(error =&gt; {
  console.error('Error:', error);
});
</pre>

<h3 id="Uploading_multiple_files">Uploading multiple files</h3>

<p>Files can be uploaded using an HTML <code>&lt;input type="file" multiple /&gt;</code> input element, {{domxref("FormData.FormData","FormData()")}} and {{domxref("GlobalFetch.fetch","fetch()")}}.</p>

<pre class="brush: js notranslate">const formData = new FormData();
const photos = document.querySelector('input[type="file"][multiple]');

formData.append('title', 'My Vegas Vacation');
for (let i = 0; i &lt; photos.files.length; i++) {
  formData.append('photos', photos.files[i]);
}

fetch('https://example.com/posts', {
  method: 'POST',
  body: formData,
})
.then(response =&gt; response.json())
.then(result =&gt; {
  console.log('Success:', result);
})
.catch(error =&gt; {
  console.error('Error:', error);
});
</pre>

<h3 id="Processing_a_text_file_line_by_line">Processing a text file line by line</h3>

<p>The chunks that are read from a response are not broken neatly at line boundaries and are Uint8Arrays, not strings. If you want to fetch a text file and process it line by line, it is up to you to handle these complications. The following example shows one way to do this by creating a line iterator (for simplicity, it assumes the text is UTF-8, and doesn't handle fetch errors).</p>

<pre class="brush: js notranslate">async function* makeTextFileLineIterator(fileURL) {
  const utf8Decoder = new TextDecoder('utf-8');
  const response = await fetch(fileURL);
  const reader = response.body.getReader();
  let { value: chunk, done: readerDone } = await reader.read();
  chunk = chunk ? utf8Decoder.decode(chunk) : '';

  const re = /\n|\r|\r\n/gm;
  let startIndex = 0;
  let result;

  for (;;) {
    let result = re.exec(chunk);
    if (!result) {
      if (readerDone) {
        break;
      }
      let remainder = chunk.substr(startIndex);
      ({ value: chunk, done: readerDone } = await reader.read());
      chunk = remainder + (chunk ? utf8Decoder.decode(chunk) : '');
      startIndex = re.lastIndex = 0;
      continue;
    }
    yield chunk.substring(startIndex, result.index);
    startIndex = re.lastIndex;
  }
  if (startIndex &lt; chunk.length) {
    // last line didn't end in a newline char
    yield chunk.substr(startIndex);
  }
}

async function run() {
  for await (let line of makeTextFileLineIterator(urlOfFile)) {
    processLine(line);
  }
}

run();
</pre>

<h3 id="Checking_that_the_fetch_was_successful">Checking that the fetch was successful</h3>

<p>A {{domxref("GlobalFetch.fetch","fetch()")}} promise will reject with a {{jsxref("TypeError")}} when a network error is encountered or CORS is misconfigured on the server-side, although this usually means permission issues or similar — a 404 does not constitute a network error, for example. An accurate check for a successful <code>fetch()</code> would include checking that the promise resolved, then checking that the {{domxref("Response.ok")}} property has a value of true. The code would look something like this:</p>

<pre class="brush: js notranslate">fetch('flowers.jpg')
  .then(response =&gt; {
    if (!response.ok) {
      throw new Error('Network response was not ok');
    }
    return response.blob();
  })
  .then(myBlob =&gt; {
    myImage.src = URL.createObjectURL(myBlob);
  })
  .catch(error =&gt; {
    console.error('There has been a problem with your fetch operation:', error);
  });
</pre>

<h3 id="Supplying_your_own_request_object">Supplying your own request object</h3>

<p>Instead of passing a path to the resource you want to request into the <code>fetch()</code> call, you can create a request object using the {{domxref("Request.Request","Request()")}} constructor, and pass that in as a <code>fetch()</code> method argument:</p>

<pre class="brush: js notranslate">const myHeaders = new Headers();

const myRequest = new Request('flowers.jpg', {
  method: 'GET',
  headers: myHeaders,
  mode: 'cors',
  cache: 'default',
});

fetch(myRequest)
  .then(response =&gt; response.blob())
  .then(myBlob =&gt; {
    myImage.src = URL.createObjectURL(myBlob);
  });
</pre>

<p><code>Request()</code> accepts exactly the same parameters as the <code>fetch()</code> method. You can even pass in an existing request object to create a copy of it:</p>

<pre class="brush: js notranslate">const anotherRequest = new Request(myRequest, myInit);
</pre>

<p>This is pretty useful, as request and response bodies are one use only. Making a copy like this allows you to make use of the request/response again while varying the <code>init</code> options if desired. The copy must be made before the body is read, and reading the body in the copy will also mark it as read in the original request.</p>

<div class="note">
<p><strong>Note</strong>: There is also a {{domxref("Request.clone","clone()")}} method that creates a copy. Both methods of creating a copy will fail if the body of the original request or response has already been read, but reading the body of a cloned response or request will not cause it to be marked as read in the original.</p>
</div>

<h2 id="Headers">Headers</h2>

<p>The {{domxref("Headers")}} interface allows you to create your own headers object via the {{domxref("Headers.Headers","Headers()")}} constructor. A headers object is a simple multi-map of names to values:</p>

<pre class="brush: js notranslate">const content = 'Hello World';
const myHeaders = new Headers();
myHeaders.append('Content-Type', 'text/plain');
myHeaders.append('Content-Length', content.length.toString());
myHeaders.append('X-Custom-Header', 'ProcessThisImmediately');
</pre>

<p>The same can be achieved by passing an array of arrays or an object literal to the constructor:</p>

<pre class="brush: js notranslate">const myHeaders = new Headers({
  'Content-Type': 'text/plain',
  'Content-Length': content.length.toString(),
  'X-Custom-Header': 'ProcessThisImmediately'
});
</pre>

<p>The contents can be queried and retrieved:</p>

<pre class="brush: js notranslate">console.log(myHeaders.has('Content-Type')); // true
console.log(myHeaders.has('Set-Cookie')); // false
myHeaders.set('Content-Type', 'text/html');
myHeaders.append('X-Custom-Header', 'AnotherValue');

console.log(myHeaders.get('Content-Length')); // 11
console.log(myHeaders.get('X-Custom-Header')); // ['ProcessThisImmediately', 'AnotherValue']

myHeaders.delete('X-Custom-Header');
console.log(myHeaders.get('X-Custom-Header')); // [ ]
</pre>

<p>Some of these operations are only useful in {{domxref("ServiceWorker_API","ServiceWorkers")}}, but they provide a much nicer API for manipulating headers.</p>

<p>All of the Headers methods throw a <code>TypeError</code> if a header name is used that is not a valid HTTP Header name. The mutation operations will throw a <code>TypeError</code> if there is an immutable guard (see below). Otherwise, they fail silently. For example:</p>

<pre class="brush: js notranslate">const myResponse = Response.error();
try {
  myResponse.headers.set('Origin', 'http://mybank.com');
} catch (e) {
  console.log('Cannot pretend to be a bank!');
}
</pre>

<p>A good use case for headers is checking whether the content type is correct before you process it further. For example:</p>

<pre class="brush: js notranslate">fetch(myRequest)
  .then(response =&gt; {
     const contentType = response.headers.get('content-type');
     if (!contentType || !contentType.includes('application/json')) {
       throw new TypeError("Oops, we haven't got JSON!");
     }
     return response.json();
  })
  .then(data =&gt; {
      /* process your data further */
  })
  .catch(error =&gt; console.error(error));
</pre>

<h3 id="Guard">Guard</h3>

<p>Since headers can be sent in requests and received in responses, and have various limitations about what information can and should be mutable, headers objects have a guard property. This is not exposed to the Web, but it affects which mutation operations are allowed on the headers object.</p>

<p>Possible guard values are:</p>

<ul>
 <li><code>none</code>: default.</li>
 <li><code>request</code>: guard for a headers object obtained from a request ({{domxref("Request.headers")}}).</li>
 <li><code>request-no-cors</code>: guard for a headers object obtained from a request created with {{domxref("Request.mode")}} <code>no-cors</code>.</li>
 <li><code>response</code>: guard for a Headers obtained from a response ({{domxref("Response.headers")}}).</li>
 <li><code>immutable</code>: Mostly used for ServiceWorkers; renders a headers object read-only.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: You may not append or set a <code>request</code> guarded Headers’ <code>Content-Length</code> header. Similarly, inserting <code>Set-Cookie</code> into a response header is not allowed: ServiceWorkers are not allowed to set cookies via synthesized responses.</p>
</div>

<h2 id="Response_objects">Response objects</h2>

<p>As you have seen above, {{domxref("Response")}} instances are returned when <code>fetch()</code> promises are resolved.</p>

<p>The most common response properties you'll use are:</p>

<ul>
 <li>{{domxref("Response.status")}} — An integer (default value 200) containing the response status code.</li>
 <li>{{domxref("Response.statusText")}} — A string (default value "OK"), which corresponds to the HTTP status code message.</li>
 <li>{{domxref("Response.ok")}} — seen in use above, this is a shorthand for checking that status is in the range 200-299 inclusive. This returns a {{domxref("Boolean")}}.</li>
</ul>

<p>They can also be created programmatically via JavaScript, but this is only really useful in {{domxref("ServiceWorker_API", "ServiceWorkers")}}, when you are providing a custom response to a received request using a {{domxref("FetchEvent.respondWith","respondWith()")}} method:</p>

<pre class="brush: js notranslate">const myBody = new Blob();

addEventListener('fetch', function(event) {
  // ServiceWorker intercepting a fetch
  event.respondWith(
    new Response(myBody, {
      headers: { 'Content-Type': 'text/plain' }
    })
  );
});
</pre>

<p>The {{domxref("Response.Response","Response()")}} constructor takes two optional arguments — a body for the response, and an init object (similar to the one that {{domxref("Request.Request","Request()")}} accepts.)</p>

<ul>
</ul>

<div class="note">
<p><strong>Note</strong>: The static method {{domxref("Response.error","error()")}} returns an error response. Similarly, {{domxref("Response.redirect","redirect()")}} returns a response resulting in a redirect to a specified URL. These are also only relevant to Service Workers.</p>
</div>

<h2 id="Body">Body</h2>

<p>Both requests and responses may contain body data. A body is an instance of any of the following types:</p>

<ul>
 <li>{{domxref("ArrayBuffer")}}</li>
 <li>{{domxref("ArrayBufferView")}} (Uint8Array and friends)</li>
 <li>{{domxref("Blob")}}/File</li>
 <li>string</li>
 <li>{{domxref("URLSearchParams")}}</li>
 <li>{{domxref("FormData")}}</li>
</ul>

<p>The {{domxref("Body")}} mixin defines the following methods to extract a body (implemented by both {{domxref("Request")}} and {{domxref("Response")}}). These all return a promise that is eventually resolved with the actual content.</p>

<ul>
 <li>{{domxref("Body.arrayBuffer","arrayBuffer()")}}</li>
 <li>{{domxref("Body.blob","blob()")}}</li>
 <li>{{domxref("Body.json","json()")}}</li>
 <li>{{domxref("Body.text","text()")}}</li>
 <li>{{domxref("Body.formData","formData()")}}</li>
</ul>

<p>This makes usage of non-textual data much easier than it was with XHR.</p>

<p>Request bodies can be set by passing body parameters:</p>

<pre class="brush: js notranslate">const form = new FormData(document.getElementById('login-form'));
fetch('/login', {
  method: 'POST',
  body: form
});
</pre>

<p>Both request and response (and by extension the <code>fetch()</code> function), will try to intelligently determine the content type. A request will also automatically set a <code>Content-Type</code> header if none is set in the dictionary.</p>

<h2 id="Feature_detection">Feature detection</h2>

<p>Fetch API support can be detected by checking for the existence of {{domxref("Headers")}}, {{domxref("Request")}}, {{domxref("Response")}} or {{domxref("GlobalFetch.fetch","fetch()")}} on the {{domxref("Window")}} or {{domxref("Worker")}} scope. For example:</p>

<pre class="brush: js notranslate">if (window.fetch) {
  // run my fetch request here
} else {
  // do something with XMLHttpRequest?
}
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>To use Fetch in unsupported browsers, there is a <a href="https://github.com/github/fetch">Fetch Polyfill</a> available that recreates the functionality for non-supporting browsers.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Fetch')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowOrWorkerGlobalScope.fetch")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
 <li><a href="https://github.com/github/fetch">Fetch polyfill</a></li>
 <li><a href="https://github.com/mdn/fetch-examples/">Fetch examples on Github</a></li>
</ul>
